// пример тюнера на синтетическом нагревательном процессе

#include "PIDtuner2.h"
PIDtuner2 tuner;

void setup() {
  Serial.begin(9600);

  // направление, начальный сигнал, конечный, период плато, точность, время стабилизации, период итерации
  tuner.setParameters(NORMAL, 0, 30, 1000, 0.1, 50);

  // направление: NORMAL - увеличение выходного сигнала увеличивает сигнал с датчика (например обогреватель, мотор)
  // REVERSE - увеличение выходного сигнала уменьшает сигнал с датчика (например холодильник, тормоз)
}

void loop() {
  float signal = process(tuner.getOutput());
  tuner.setInput(signal);
  tuner.compute();

  // выводит в порт текстовые отладочные данные, включая коэффициенты
  tuner.debugText();

  // выводит в порт данные для построения графиков, без коэффициентов
  //tuner.debugPlot();
}
